



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[HDOJ - 5208] Where is Bob 【DFS+按位贪心】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[HDOJ - 5208] Where is Bob 【DFS+按位贪心】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 15:20:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：<a href="http://acm.hdu.edu.cn/showproblem.php?pid=5208" rel="external nofollow noreferrer">HDOJ - 5208</a></p>
<h3>题目分析</h3>
<p>使用按位贪心的思想，即从高位向低位枚举，尽量使这一位的答案为 1 。</p>
<p>我们使用 DFS ，每次就是对于 &nbsp;[l1, r1] [l2, r2] x &nbsp;进行处理，其中，x 是当前处理的最高位的权值，即 2^i 。</p>
<p>如果 A 和 B 两人的区间的最高位都确定了，那就记录这一位的答案，直接处理下一位。</p>
<p>如果 A 可以取 0/1 ，而 B 已经确定了，那么 A 就一定要取与 B 相反的那个。</p>
<p>如果 A 和 B 都能取 0/1 ，那么我们就要分支进行 DFS ，一种是 A-1 B-1 ，另一种是 A-0 B-0 ，然后取这两种情况答案的较大值。</p>
<p>然而剪枝是十分有效的，必须加上&ldquo;如果 B 的区间完全包含了 A 的区间，直接返回 0&rdquo;。不加这句就会 TLE 。（这样能将大部分分支剪掉？）</p>
<p>另外，如果当前的区间是 [l, r] &nbsp; &nbsp;l &lt; x &amp;&amp; r &gt;= x</p>
<p>那么最高位就可以选 0 也可以选 1。</p>
<p>如果决策选 0 ，那么到下一位的区间就变为 [l, x - 1] 。</p>
<p>如果决策选 1 ，那么到下一位的区间就变为 [x, r - x]。</p>
<h3>代码</h3>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;cstdlib&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;algorithm&gt;

using namespace std;

inline int gmax(int a, int b) {return a &gt; b ? a : b;}

int Ans, l, r, ll, rr, T;

int Solve(int l, int r, int ll, int rr, int x)<br />
{<br />
	if (x == 0 || (ll &lt;= l &amp;&amp; rr &gt;= r)) return 0;<br />
	int v, vv;<br />
	if (r &lt; x) v = 0;<br />
	else if (l &gt;= x) v = 1;<br />
	else v = 2;<br />
	if (rr &lt; x) vv = 0;<br />
	else if (ll &gt;= x) vv = 1;<br />
	else vv = 2;<br />
	if (v == 0)<br />
	{<br />
		if (vv == 0) // A-0 B-0<br />
			return Solve(l, r, ll, rr, x &gt;&gt; 1);<br />
		else if (vv == 1) // A-0 B-1<br />
			return x + Solve(l, r, ll - x, rr - x, x &gt;&gt; 1);<br />
		else // A-0 B-0-1<br />
			return Solve(l, r, ll, x - 1, x &gt;&gt; 1);<br />
	}<br />
	else if (v == 1)<br />
	{<br />
		if (vv == 0) // A-1 B-0<br />
			return x + Solve(l - x, r - x, ll, rr, x &gt;&gt; 1);<br />
		else if (vv == 1) // A-1 B-1<br />
			return Solve(l - x, r - x, ll - x, rr - x, x &gt;&gt; 1);<br />
		else // A-1 B-0-1<br />
			return Solve(l - x, r - x, 0, rr - x, x &gt;&gt; 1);<br />
	}<br />
	else<br />
	{<br />
		if (vv == 0) // A-0-1 B-0<br />
			return x + Solve(0, r - x, ll, rr, x &gt;&gt; 1);<br />
		else if (vv == 1) // A-0-1 B-1<br />
			return x + Solve(l, x - 1, ll - x, rr - x, x &gt;&gt; 1);<br />
		else // A-0-1 B-0-1<br />
			return gmax(Solve(l, x - 1, ll, x - 1, x &gt;&gt; 1), Solve(0, r - x, 0, rr - x, x &gt;&gt; 1));<br />
	}<br />
}

int main()<br />
{<br />
	scanf("%d", &amp;T);<br />
	for (int Case = 1; Case &lt;= T; ++Case)<br />
	{<br />
		scanf("%d%d%d%d", &amp;l, &amp;r, &amp;ll, &amp;rr);<br />
		Ans = Solve(l, r, ll, rr, 1 &lt;&lt; 30);<br />
		printf("Case #%d: %d\n", Case, Ans);<br />
	}<br />
	return 0;<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q77j11q.html">qt creator 源代码中含有中文编译报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdojj08.html">pandas应用之分组因子暴露和分位数分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1l0z58.html">mfc MemoryAdressRead</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrz0lq.html">xml基础总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvondz8.html">hdu1054   树形dp&amp;amp&semi;&amp;amp&semi;二分图</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zn6618.html">UITableViewCell左对齐的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o50yj9.html">实例源码--IOS高仿微信打飞机游戏&lpar;完整功能&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1y3r59.html">MySQL&lowbar;数据分页查询（limit用法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrod38.html">easyUI datagrid 动态绑定列名称</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy15mrmq.html">不再迷惑，无值和NULL值的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zr5zg9.html">Atcoder刷题小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj305g8.html">HTML（九）HTML 条件注释规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25d2xlq.html">webpack学习笔记 &lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjw1n79.html">SpringCloud调用服务示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjzznxq.html">可视化库-seaborn-回归分析绘图&lpar;第五天&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/902knknq.html">Python 自动爬取B站视频</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp0j249.html">【agc003E】Sequential operations on Sequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndm0wg8.html">1568&colon; &lbrack;JSOI2008&rsqb;Blue Mary开公司</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwodr6z9.html">DependencyProperty&period;UnsetValue 的正确打开方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwod1py9.html">linux中awk工具</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pj6m449.html">Android应用源码图书馆管理系统带服务端数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydn4gmq.html">谷歌google搜索打不开、谷歌gmail邮箱及相关服务无法登录的解决的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm6dd79.html">CentOS 7&period;2 修改主机名</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydnrndq.html">PureMVC&lpar;JS版）源码解析（六）：MacroCommand类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmd5ge9.html">magic&lowbar;quotes&lowbar;runtime（魔术引号开关）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnj5yd8.html">oracle授权另外一个用户访问自己创建的数据对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y5700q.html">27、Jquery 事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okplnl9.html">python 简明教程笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn160m38.html">C&num; Ref 与out 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okpo5e9.html">IIS本地部署项目出错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
